<?php
namespace SM\Controller;

use Zeedhi\Framework\DTO\Request;
use SM\Service\ConfContratoMotivoRescisaoService;
use SM\Traits\TResponse;

class ConfContratoMotivoRescisaoController
{

    use TResponse;

    protected $motivoRescisaoService;

    public function __construct(ConfContratoMotivoRescisaoService $motivoRescisaoService)
    {
        $this->motivoRescisaoService = $motivoRescisaoService;
    }

    public function getMotivoRecisao()
    {
        try {
            $data = $this->motivoRescisaoService->getMotivoRecisao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarMotivos(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->motivoRescisaoService->salvarMotivos($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirMotivos(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->motivoRescisaoService->excluirMotivos($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
