/*
TECNISA - TECNOLOGIA EM INFORMTICA

NOME: SUM_EFETIVOS

DESCRIO:
PROCEDIMENTO RETORNO DA SOMA DOS EFETIVOS.

CRIAO:
19/12/2001 - ANA PAULA DA SILVA
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'SUM_EFETIVOS' AND
                 TYPE = 'V' 		        AND
                 U.UID = O.UID           AND
                 U.NAME = USER)
DROP VIEW SUM_EFETIVOS
GO
CREATE VIEW SUM_EFETIVOS AS
SELECT 'P' IDFATUPLAN, EFETCLIE.CDFILIAL, EFETCLIE.CDCLIENTE, NULL AS CDTURNO,
       EFETCLIE.DTEFETCLIE AS DTFATURAM, EFETCLIE.CDSERVFILI,
       SERVCLIE.CDGRSERVFAT, SERVICO.CDPRODUTO, SERVCLIE.CDPTOVNDFATUR,
       EFETCLIE.QTCOMEFETCLI QTEFETIVOS, EFETCLIE.VRSERVFATUEFCLI VRSERVFATUDT,
       TEKNISA.CALCVALRSERV(EFETCLIE.CDFILIAL, EFETCLIE.CDCLIENTE, EFETCLIE.CDSERVFILI, EFETCLIE.DTEFETCLIE, NULL) VRSERVICO,
       TEKNISA.DsNmServicoTur(EFETCLIE.CDFILIAL, EFETCLIE.CDCLIENTE, EFETCLIE.CDSERVFILI, DTEFETCLIE, NULL) NMSERVICO,
       EFETCLIE.CDSERVPLAN, EFETCLIE.QTVENDAEFETCLI
FROM EFETCLIE, SERVCLIE, SERVICO
WHERE
      EFETCLIE.CDFILIAL    = SERVCLIE.CDFILIAL   AND
      EFETCLIE.CDCLIENTE   = SERVCLIE.CDCLIENTE  AND
      EFETCLIE.CDSERVFILI  = SERVCLIE.CDSERVFILI AND
      EFETCLIE.QTCOMEFETCLI <> 0                 AND
      SERVICO.CDFILIAL     = EFETCLIE.CDFILIAL   AND
      SERVICO.CDSERVFILI   = EFETCLIE.CDSERVFILI AND
      ((SERVICO.IDFATUSERV   <> 'N') OR (SERVICO.IDFATUSERV IS NULL)) AND
      NOT EXISTS (SELECT CDFILIAL, CDSERVFILI,CDCLIENTE, DTFATTURNO
                    FROM TURNOCLIE
                  WHERE TURNOCLIE.CDFILIAL     = EFETCLIE.CDFILIAL   AND
                        TURNOCLIE.CDSERVFILI   = EFETCLIE.CDSERVFILI AND
                        TURNOCLIE.CDCLIENTE    = EFETCLIE.CDCLIENTE  AND
                        TURNOCLIE.DTFATTURNO   = EFETCLIE.DTEFETCLIE)      
UNION

SELECT 'P' IDFATUPLAN, TURNOCLIE.CDFILIAL,  TURNOCLIE.CDCLIENTE,
       TURNOCLIE.CDTURNO, TURNOCLIE.DTFATTURNO AS DTFATURAM, TURNOCLIE.CDSERVFILI, 
       '' AS CDGRSERVFAT,    SERVICO.CDPRODUTO, ' ' AS CDPTOVNDFATUR,       
       TURNOCLIE.QTCOMTURNCLI QTEFETIVOS, 0 AS VRSERVFATUDT,
       TEKNISA.CALCVALRSERVTUR(TURNOCLIE.CDFILIAL, TURNOCLIE.CDCLIENTE, TURNOCLIE.CDSERVFILI, TURNOCLIE.DTFATTURNO, TURNOCLIE.CDTURNO) VRSERVICO,
       TEKNISA.DsNmServicoTur (TURNOCLIE.CDFILIAL, TURNOCLIE.CDCLIENTE, TURNOCLIE.CDSERVFILI, TURNOCLIE.DTFATTURNO, TURNOCLIE.CDTURNO) NMSERVICO,
       TURNOCLIE.CDSERVFILI AS CDSERVPLAN, 0 AS QTVENDAEFETCLI
FROM TURNOCLIE, SERVICO
WHERE TURNOCLIE.QTCOMTURNCLI  <> 0                       AND
      SERVICO.CDFILIAL     = TURNOCLIE.CDFILIAL       AND
      SERVICO.CDSERVFILI   = TURNOCLIE.CDSERVFILI     AND
      ((SERVICO.IDFATUSERV   <> 'N') OR (SERVICO.IDFATUSERV IS NULL))
         
UNION

SELECT 'F' IDFATUPLAN, EFECLIFAT.CDFILIAL, EFECLIFAT.CDCLIENTE, NULL AS CDTURNO,
       EFECLIFAT.DTFATURAM, EFECLIFAT.CDSERVFILI,
       SERVCLIE.CDGRSERVFAT, SERVICO.CDPRODUTO, SERVCLIE.CDPTOVNDFATUR,
       EFECLIFAT.QTCOMEFATU QTEFETIVOS, NULL AS VRSERVFATUDT,
       TEKNISA.CALCVALRSERV(EFECLIFAT.CDFILIAL, EFECLIFAT.CDCLIENTE, EFECLIFAT.CDSERVFILI, EFECLIFAT.DTFATURAM, NULL) VRSERVICO,
       TEKNISA.DsNmServicoTur(EFECLIFAT.CDFILIAL, EFECLIFAT.CDCLIENTE, EFECLIFAT.CDSERVFILI, DTFATURAM, NULL) NMSERVICO,
       EFECLIFAT.CDSERVPLAN AS CDSERVPLAN, 0 AS QTVENDAEFETCLI
FROM EFECLIFAT, SERVCLIE, SERVICO
WHERE
      EFECLIFAT.CDFILIAL   = SERVCLIE.CDFILIAL    AND
      EFECLIFAT.CDCLIENTE  = SERVCLIE.CDCLIENTE   AND
      EFECLIFAT.CDSERVFILI = SERVCLIE.CDSERVFILI  AND
      EFECLIFAT.QTCOMEFATU <> 0                   AND
      SERVICO.CDFILIAL     = EFECLIFAT.CDFILIAL   AND
      SERVICO.CDSERVFILI   = EFECLIFAT.CDSERVFILI AND
      ((SERVICO.IDFATUSERV   <> 'N') OR (SERVICO.IDFATUSERV IS NULL)) AND
      ((SERVICO.IDFATUSERV   <> 'N') OR (SERVICO.IDFATUSERV IS NULL)) AND
       NOT EXISTS (SELECT CDFILIAL, CDSERVFILI,CDCLIENTE, DTFATURAMTUR
                   FROM EFECLIFATTUR
                   WHERE EFECLIFATTUR.CDFILIAL     = EFECLIFAT.CDFILIAL   AND
                         EFECLIFATTUR.CDSERVFILI   = EFECLIFAT.CDSERVFILI AND
                         EFECLIFATTUR.CDCLIENTE    = EFECLIFAT.CDCLIENTE  AND
                         EFECLIFATTUR.DTFATURAMTUR = EFECLIFAT.DTFATURAM)
UNION

SELECT 'F' IDFATUPLAN, EFECLIFATTUR.CDFILIAL, EFECLIFATTUR.CDCLIENTE,
       EFECLIFATTUR.CDTURNO, EFECLIFATTUR.DTFATURAMTUR AS DTFATURAM, EFECLIFATTUR.CDSERVFILI,
       NULL AS CDGRSERVFAT, SERVICO.CDPRODUTO,  ' ' AS CDPTOVNDFATUR,
       EFECLIFATTUR.QTCOMFATUTUR QTEFETIVOS, 0 AS VRSERVFATUDT,
       TEKNISA.CALCVALRSERVTUR(EFECLIFATTUR.CDFILIAL, EFECLIFATTUR.CDCLIENTE, EFECLIFATTUR.CDSERVFILI, EFECLIFATTUR.DTFATURAMTUR, EFECLIFATTUR.CDTURNO) VRSERVICO,
       TEKNISA.DsNmServicoTur (EFECLIFATTUR.CDFILIAL, EFECLIFATTUR.CDCLIENTE, EFECLIFATTUR.CDSERVFILI, EFECLIFATTUR.DTFATURAMTUR, EFECLIFATTUR.CDTURNO) NMSERVICO, 
       EFECLIFATTUR.CDSERVFILI AS CDSERVPLAN, 0 AS QTVENDAEFETCLI
FROM EFECLIFATTUR, SERVICO
WHERE EFECLIFATTUR.QTCOMFATUTUR  <> 0                    AND
      SERVICO.CDFILIAL     = EFECLIFATTUR.CDFILIAL       AND
      SERVICO.CDSERVFILI   = EFECLIFATTUR.CDSERVFILI     AND
      ((SERVICO.IDFATUSERV   <> 'N') OR (SERVICO.IDFATUSERV IS NULL))

GO

-- VERSAO --
EXEC ATUVEROBJ 'SUM_EFETIVOS','4.11.162';
GO
