create or replace FUNCTION CNC_DATA_VENC(P_CDFILIAL IN VARCHAR,
                                         P_DTVENC IN DATE,
                                         P_DIASVENC IN NUMBER,
                                         P_CDTIPORECE IN VARCHAR DEFAULT NULL) RETURN DATE
AS
   V_DATAFIN DATE;
   V_COUNT NUMBER;
   V_CDFORMPGTO TIPORECE.CDFORMPGTO%TYPE;
   V_IDTIPODTPGTO VARCHAR2(10);
   V_IDTPPERIODO VARCHAR2(10);
   V_DTVENCIMENTO DATE;
   
   /*CORRIGE A DATA DE VENCIMENTO CONSIDERANDO FERIADO BANCRIO*/
   PROCEDURE CONSISTE_FERI_BANC(P_CDFILIEMIRECE IN VARCHAR2,
                                P_DTVENCIMENTO IN DATE,
                                P_IDTIPODTPGTO IN VARCHAR2,
                                P_DTEMISSAO IN DATE,
                                P_DTVENC OUT DATE)
   IS
      V_BOFERI BOOLEAN;
      V_NRDIASFERI NUMBER;
      V_DTANTERIOR DATE;
      V_IDCONSCALVENNF VARCHAR2(1);
   BEGIN
      V_BOFERI := TRUE;
      P_DTVENC := P_DTVENCIMENTO;

      BEGIN
         SELECT IDCONSCALVENNF
           INTO V_IDCONSCALVENNF
           FROM PARAMFILIAL
          WHERE CDFILIAL = P_CDFILIEMIRECE;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
              V_IDCONSCALVENNF := NULL;
      END;
      WHILE V_BOFERI LOOP
         IF P_IDTIPODTPGTO = 'EMEX' THEN
            BEGIN
               IF V_IDCONSCALVENNF = 'F' THEN
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERIFILI
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERIFILI BETWEEN P_DTEMISSAO+1 AND P_DTVENC;
               ELSIF V_IDCONSCALVENNF = 'C' THEN
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERICOMP
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERICOMP BETWEEN P_DTEMISSAO+1 AND P_DTVENC;
               ELSE
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERIBANC
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERIBANC BETWEEN P_DTEMISSAO+1 AND P_DTVENC;
               END IF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_NRDIASFERI := 0;
            END;
         ELSE
            BEGIN
               IF V_IDCONSCALVENNF = 'F' THEN
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERIFILI
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERIFILI BETWEEN P_DTEMISSAO AND P_DTVENC;
               ELSIF V_IDCONSCALVENNF = 'C' THEN
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERICOMP
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERICOMP BETWEEN P_DTEMISSAO AND P_DTVENC;
               ELSE
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERIBANC
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERIBANC BETWEEN P_DTEMISSAO AND P_DTVENC;
               END IF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_NRDIASFERI := 0;
            END;
         END IF;
         IF NOT(V_NRDIASFERI = 0) THEN
            V_DTANTERIOR := P_DTVENC;
            P_DTVENC := P_DTVENC + V_NRDIASFERI;
            WHILE V_BOFERI LOOP
               V_DTANTERIOR := V_DTANTERIOR+1;
               BEGIN
                  IF V_IDCONSCALVENNF = 'F' THEN
                     SELECT COUNT(*)
                       INTO V_NRDIASFERI
                       FROM FERIFILI
                      WHERE CDFILIAL = P_CDFILIEMIRECE
                        AND DTFERIFILI BETWEEN V_DTANTERIOR AND P_DTVENC;
                  ELSIF V_IDCONSCALVENNF = 'C' THEN
                     SELECT COUNT(*)
                       INTO V_NRDIASFERI
                       FROM FERICOMP
                      WHERE CDFILIAL = P_CDFILIEMIRECE
                        AND DTFERICOMP BETWEEN V_DTANTERIOR AND P_DTVENC;
                  ELSE
                     SELECT COUNT(*)
                       INTO V_NRDIASFERI
                       FROM FERIBANC
                      WHERE CDFILIAL = P_CDFILIEMIRECE
                        AND DTFERIBANC BETWEEN V_DTANTERIOR AND P_DTVENC;
                  END IF;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NRDIASFERI := 0;
               END;
               IF V_NRDIASFERI > 0 THEN
                  V_DTANTERIOR := P_DTVENC;
                  P_DTVENC := P_DTVENC + V_NRDIASFERI;
               ELSE
                  V_BOFERI := FALSE;
               END IF;
            END LOOP;
         ELSE
            V_BOFERI := FALSE;
         END IF;
      END LOOP;
   END;
BEGIN
   V_DTVENCIMENTO := P_DTVENC + P_DIASVENC;
   V_DATAFIN := V_DTVENCIMENTO;
   CONSISTE_FERI_BANC(P_CDFILIAL,
                      V_DATAFIN,
                      V_IDTIPODTPGTO,
                      P_DTVENC,
                      V_DATAFIN);
   BEGIN
      SELECT NVL(TRF.CDFORMPGTO,    TR.CDFORMPGTO) AS CDFORMPGTO
        INTO V_CDFORMPGTO
        FROM TIPORECE TR, TIPORECEFILIAL TRF
       WHERE TR.CDTIPORECE = P_CDTIPORECE
         AND TRF.CDFILIAL(+) = P_CDFILIAL
         AND TR.CDTIPORECE   = TRF.CDTIPORECE(+);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDFORMPGTO := 0;
   END;
   IF V_CDFORMPGTO IS NOT NULL THEN
      SELECT IDTIPODTPGTO, IDTPPERIODO
        INTO V_IDTIPODTPGTO, V_IDTPPERIODO
        FROM FORMPGTO
       WHERE CDFORMPGTO = V_CDFORMPGTO;
      IF V_IDTPPERIODO = 'M' THEN
         V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIAMES(V_CDFORMPGTO,
                                                      V_DATAFIN);
      ELSIF V_IDTPPERIODO = 'S' THEN
         V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANA(V_CDFORMPGTO,
                                                         V_DATAFIN);
      ELSE
         V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANAMES(V_CDFORMPGTO,
                                                            V_DATAFIN);
      END IF;
   END IF;

   RETURN V_DATAFIN;
END;
/